%N=128;  %number of points to use in reconstruction, default is 128
smin(1:N)=0;
csmin(1:N)=0;
arbitrary=0;
pt=0;
fval = 10;
forloopCt = 0;
t = (1:N);
w = (1:N);
zeros(1:N)=0;

goal(1:N)=0; %set goal for error function when using Quasi-Newton search
weight(1:N)=1;  %set weight to dataset when using Quasi-Newton search
lb=-1.25;  %lower limit on A B C coeffs
ub=1.25;  %upper limit on A B C coeffs
LB=[-0.25, -0.25, -0.001];  %lower limit on ABC coeffs for GA
UB=[0.25, 0.25, 0.001];  %upper limit on ABC coeffs for GA

guess1 = 0; %guess for inital A coeff
guess2 = 0; %B coeff
guess3 = 0; %and C coeff

tol = 5e-5; %tolerance

 
%SminM = load('-ascii','Laser12-12-06LEDSmin.TXT');
%LinCorr = load('-ascii','LinCorrLED12-12-06.TXT');
%Mspectrum = fftshift(abs(fft(LinCorr,fftRange)));  %Measured spectrum

%plot(Mspectrum,'.-k');

Smax(1:N)=0;
Smin(1:N)=0;
time(1:N)=0;

n = length(SminM);
delta = round(n/N);

[volts, ZeroDelay] = max(SmaxM);

oodelta  = 1;  %spectral sampling

for q = 1:N

          if ZeroDelay-pt*delta >=1  %  forcing smin and smax at zero delay to be in the middle of recon
           if q < 1+N/2
              Smin(N/2+1-q) = SminM(ZeroDelay-pt*delta);
              Smax(N/2+1-q) = SmaxM(ZeroDelay-pt*delta);
              time(N/2+1-q) = TimeAxis(ZeroDelay-pt*delta);
            end;
          end;
 
          pt = pt + 1;
 
                    if q==(N/2+1)
                      pt=1;
                    end;
         
         if ZeroDelay+pt*delta <= n
           if q >= 1+N/2
               Smin(q) = SminM(ZeroDelay+pt*delta);
               Smax(q) = SmaxM(ZeroDelay+pt*delta);
               time(q) = TimeAxis(ZeroDelay+pt*delta);
           end;
          end;
end;
q=1;
pt=0;

if acquire == 1
       spectrum(1:N)=0;
            for q = 1:N
                      if W0-pt*oodelta >= 1 %  Shifting spectrum from W0 to zero
                       if q < 1+N/2
                          spectrum(N/2+1-q) = Mspectrum(W0-pt*oodelta);
                        end;
                      end;


                     pt = pt + 1;

                                if q==(N/2+1)
                                   pt=1;
                                end;
                    if W0+pt*oodelta < n
                      if q >= 1+N/2
                           spectrum(q) = Mspectrum(W0+pt*oodelta);
                       end;
                    end;

            end;
end;

W0=N/2;
deltaT = time(2)-time(1);
timeaxis = 1:N;
timeaxis = deltaT.*timeaxis;
deltaNu = 1/(TimeAxis(n)-TimeAxis(1));
freqaxis = w.*deltaNu.*1000;
freqaxis = freqaxis - freqaxis(N/2);
timeaxis = timeaxis - timeaxis(N/2);
spectrum=spectrum/max(spectrum);
spectrum(1:speczero(1))=0;  %55 eliminating spectral noise in wings of spectrum
spectrum(speczero(2):N)=0;  %76

% ampW = (abs(spectrum)).^.5; %amplitude fourier sqrt(spectrum)                           
% pulseF = ampW; %pulse fourier domain
% pulseT = fftshift(ifft(pulseF)); %pulse time domain
% Iten = pulseT.* conj(pulseT);
% Iten2 = pulseT.* pulseT;
% Iten = Iten/max(abs(Iten));
% Iten2 = Iten2/max(abs(Iten2));
% 
% A0min = xcorr(Iten);
% A2 = xcorr(Iten2,Iten2);
% A0min = A0min/real(max(A0min));
% A2 = A2/abs(max(A2));
% 
% csmin = A0min - abs(A2);
% Csmin = csmin(N/2+1:3*N/2);
% A0min = A0min(N/2+1:3*N/2);
% A2 = A2(N/2+1:3*N/2);
mA0=Smax;%+Smin;
mA0=mA0/max(mA0);

measurements = [spectrum; Smin; mA0];             
options = optimset('TolFun', 1e-15, 'TolX', 1e-15,'TolCon', 1e-10, 'GoalsExactAchieve', N,'MaxIter', 1000,'MaxFunEvals', 1000,'NonlEqnAlgorithm', 'dogleg','DiffMaxChange',1e-1,'DiffMinChange', 1e-12,'Display', 'off');
goptions = gaoptimset('PopulationSize',20, 'TolCon', 1e-16, 'TolFun', 1e-16, 'Generations', 2500);%for GA
poptions = psoptimset('Cache','off','MeshAccelerator','off','TolMesh',1e-10,'TolX',1e-8,'TolFun',1e-6);%options for pattern search

if method == 0  %Quasi-Newton line search, poly phase
    order = [1; 0; 0];%first optimize A; B=C=0
    [abc, fval, attainfactor, exitflag, output] = fgoalattain(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],goal,1+Smax,[],[],[],[],lb,ub,[],options);  
    guess1 = abc(1);%A
    order = [1; 1; 0];%now optimize A and B; C=0
    if fval > tol
    [abc, fval, attainfactor, exitflag, output] = fgoalattain(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],goal,1+Smax,[],[],[],[],lb,ub,[],options);
    guess1 = abc(1);%A
    guess2 = abc(2);%B
    end;
    order = [1; 1; 1];%now optimize A, B and C
    if fval > tol
    [abc, fval, attainfactor, exitflag, output] = fgoalattain(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],goal,1+Smax,[],[],[],[],lb,ub,[],options);  
    guess1 = abc(1);%A
    guess2 = abc(2);%B
    guess3 = abc(3);%C
    end;
end;
  
if method == 4  %Genetic Algorithm, poly phase
    order = [1; 1; 0];  
    if fval > tol
        [abc, fval, reason, output] = ga(@(x) MosaicError(x, measurements, order, W0, w, N),3,[],[],[],[],LB,UB,[],goptions);
        guess1 = abc(1);
        guess2 = abc(2);
        guess3 = abc(3);
    end;   
end;
    
if method == 1  %Nelder-Mead Simplex direct search, poly phase
    order = [1; 0; 0];
    [abc, fval, exitflag, output] = fminsearch(@(x) MosaicError(x, measurements, order, W0, w, N),[guess1; guess2; guess3],options);
    guess1 = abc(1);
    order = [1; 1; 0];  
    if fval > tol
    [abc, fval, exitflag, output] = fminsearch(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],options);
    guess1 = abc(1);
    guess2 = abc(2);
    end;
    order = [1; 1; 1];  
    if fval > tol
    [abc, fval, exitflag, output] = fminsearch(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],options);
    guess1 = abc(1);
    guess2 = abc(2);
    guess3 = abc(3);  
    end;
end;
 
if method == 3  %Pattern search, poly phase
    order = [1; 0; 0];
    [abc, fval, exitflag, output] = patternsearch(@(x) MosaicError(x, measurements, order, W0, w, N),[guess1; guess2; guess3],[],[],[],[],LB,UB,[],poptions);
    guess1 = abc(1);
    order = [1; 1; 0];  
    if fval > tol
    [abc, fval, exitflag, output] = patternsearch(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],[],[],[],[],LB,UB,[],poptions);
    guess1 = abc(1);
    guess2 = abc(2);
    end;
    order = [1; 1; 1];  
    if fval > tol
    %[abc, fval, exitflag, output] = patternsearch(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],[],[],[],[],LB,UB,[],poptions);
    %guess1 = abc(1);
    %guess2 = abc(2);
    %guess3 = abc(3);  
    end;
end;

if method == 2  %Levenberg-Marquardt line search, poly phase
    order = [1; 0; 0];
    [abc, fval, exitflag, output] = fsolve(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],options);
    guess1 = abc(1);
    order = [1; 1; 0];  
    if fval > tol
    [abc, fval, exitflag, output] = fsolve(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],options);
    guess1 = abc(1);
    guess2 = abc(2);
    end;
    order = [1; 1; 1];  
    if fval > tol
    %[abc, fval, exitflag, output] = fsolve(@(x) MosaicError(x, measurements, order, W0, w, N), [guess1; guess2; guess3],options);
    %guess1 = abc(1);
    %guess2 = abc(2);
    %guess3 = abc(3);  
    end;
end;

phaseWk = guess1*(w-W0).^2 + guess2*(w-W0).^3 + guess3*(w-W0).^4;%form an N-point vector from A, B, C
options = optimset('TolFun', 1e-15, 'TolX', 1e-15,'TolCon', 1e-15, 'GoalsExactAchieve', N,'MaxIter', 10000,'MaxFunEvals', 20000,'NonlEqnAlgorithm', 'dogleg','DiffMaxChange',1e-1,'DiffMinChange', 1e-12,'Display', 'off');
poptions = psoptimset('Cache','on','MeshAccelerator','on');%options for pattern search
goptions = gaoptimset('MigrationInterval',30,'MigrationDirection','forward','CrossoverFraction',.25,'CrossoverFcn',@crossoverheuristic ,'SelectionFcn',@selectiontournament,'EliteCount',2,'PopulationSize',20,'MigrationFraction',.1, 'TolFun',1e-18, 'InitialPopulation', phaseWk,'Generations', 2500, 'FitnessLimit', tol);%options for genetic algorithm

if Arb == 1  %arbitrary phase fitting if poly phase doesn't produce fit to user satisfaction
    if method2 == 0
      [ArbPhase, fval, attainfactor, exitflag, output] = fgoalattain(@(x) MosaicError2(x, measurements, N), phaseWk, goal, 1+Smax,[],[],[],[],lb,ub,[],options);%Quasi-Newton            
    end;
    if method2 == 1
      [ArbPhase, fval, exitflag, output] = fminsearch(@(x) MosaicError2(x, measurements, N),phaseWk,options);%Nelder Mead Simplex
    end;
    if method2 == 2
      [ArbPhase, fval, exitflag, output] = fsolve(@(x) MosaicError2(x, measurements, N),phaseWk,options);%Levenberg Marquardt
    end;
    if method2 == 3
      [ArbPhase, fval, exitflag, output] = patternsearch(@(x) MosaicError2(x, measurements, N),phaseWk,[],[],[],[],[],[],[],poptions);% Direct Pattern Search
    end;
    if method2 == 4
    [ArbPhase, fval, exitflag, output] = ga(@(x) MosaicError2(x, measurements,N),N,[],[],[],[],[],[],[],goptions);  %genetic algorithm
    end;
 
    spectrum = measurements(1, :);
    Smin = measurements(2, :);
    Smax = measurements(3, :);

                phaseWk = ArbPhase;
                
                Spectrum = (abs(spectrum)).^.5; %o.o. spectrum
                
                pulseF = Spectrum.*exp(i.*phaseWk); %pulse fourier domain
                
                pulseT = fftshift(ifft(pulseF)); %pulse time domain
                
                Iten = pulseT.* conj(pulseT);
                Iten2 = pulseT.* pulseT;
                
                Iten = Iten/max(abs(Iten));
                Iten2 = Iten2/max(abs(Iten2));   
	
                A0 = xcorr(Iten);

                A2 = xcorr(Iten2,Iten2);
                A0 = A0/real(max(A0));
                A2 = A2/abs(max(A2));
                                
                csmin = A0 - abs(A2);
                Csmin = csmin(N/2+1:3*N/2);
                A0 = A0(N/2+1:3*N/2);
                

   RMOSAIC = plot(timeaxis, [Csmin; A0], '.k', timeaxis, [Smin; Smax], 'm');
   arbitrary=1;
end;

if arbitrary == 0
  A = abc(1);
  B = abc(2);
  C = abc(3);


  spectrum = measurements(1, :);
  Smin = measurements(2, :);
  Smax = measurements(3, :);


                phaseWk = A*(w-W0).^2 + B*(w-W0).^3 + C*(w-W0).^4;
                
                Spectrum = (abs(spectrum)).^.5; %o.o. spectrum
                
                pulseF = Spectrum.*exp(i.*phaseWk); %pulse fourier domain
                
                pulse = fftshift(ifft(pulseF)); %pulse time domain
                
                pulseT = pulse;

                Iten = pulseT.* conj(pulseT);
                Iten2 = pulseT.* pulseT;
                
                Iten = Iten/max(abs(Iten));
                Iten2 = Iten2/max(abs(Iten2));   
	
                A0 = xcorr(Iten);

                A2 = xcorr(Iten2,Iten2);
                A0 = A0/real(max(A0));
                A2 = A2/abs(max(A2));
                                
                csmin = A0 - abs(A2);
                Csmin = csmin(N/2+1:3*N/2);
                A0 = A0(N/2+1:3*N/2);
                
  estchirp = [A B C];  
  %RMOSAIC = plot(timeaxis, [Csmin; A0], '.k', timeaxis, [Smin; Smax], 'm');
  A = A/(2*pi*deltaNu)^2;  %units of fs^2
  B = B/(2*pi*deltaNu)^3;  %fs^3
  C = C/(2*pi*deltaNu)^4;  %fs^4
  chirpcoeffs = [A B C];
end; 
